booktracker/urls.py
from django.urls import path

from . import views


app_name = 'booktracker'
urlpatterns = [
    path('', views.BookList.as_view(), name='index'),
    path('create/', views.BookCreate.as_view(), name='book_create'),
    path('<int:pk>/', views.BookDetail.as_view(), name='detail'),
    path('<int:pk>/update/', views.BookUpdate.as_view(), name='book_update'),
    path('<int:book_id>/lend/', views.LoanCreate.as_view(), name='book_lend'),
    path('<int:book_id>/return/', views.book_return, name='book_return'),
]

knihovnicka/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('booktracker/', include('booktracker.urls')),
    #path('admin/', admin.site.urls),
]

booktracker/models.py
from django.db import models


class Book(models.Model):
    title = models.CharField(max_length=200)
    author = models.CharField(max_length=200)
    pub_year = models.IntegerField()
    is_available = models.BooleanField(default=True)


class Loan(models.Model):
    book = models.ForeignKey(Book, on_delete=models.CASCADE)
    borrower = models.CharField(max_length=200)
    return_deadline = models.DateField()

booktracker/forms.py
from django import forms
from .models import Book, Loan


class AuthorForm(forms.ModelForm):
    class Meta:
        model = Book
        fields = ['author']


class BorrowerForm(forms.ModelForm):
    class Meta:
        model = Loan
        fields = ['borrower']

booktracker/views.py
from django.shortcuts import get_object_or_404
from django.http import HttpResponseRedirect
from django.urls import reverse, reverse_lazy
from django.views.generic import DetailView, ListView, CreateView, UpdateView

from .models import Book, Loan
from .forms import AuthorForm, BorrowerForm


class BookList(ListView):
    model = Book
    template_name = 'booktracker/index.html'

    def get_queryset(self):  # how to make it prettier?
        filtered_list = Book.objects.all()
        try:
            filtered_list = filtered_list.filter(author=self.request.GET['author'])
        except KeyError:
            pass
        try:
            if self.request.GET['lent']:
                filtered_list = filtered_list.filter(is_available=False)
        except KeyError:
            pass
        try:
            id_list = Loan.objects.filter(borrower=self.request.GET['borrower']).values_list('book', flat=True)
            filtered_list = filtered_list.filter(pk__in=id_list)
        except KeyError:
            pass
        return filtered_list

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['form_author'] = AuthorForm()
        context['form_borrower'] = BorrowerForm()
        return context


class BookCreate(CreateView):
    model = Book
    fields = ['title', 'author', 'pub_year']
    template_name = 'booktracker/basic_form.html'
    success_url = reverse_lazy('booktracker:index')


class BookUpdate(UpdateView):
    model = Book
    fields = ['title', 'author', 'pub_year']
    template_name = 'booktracker/basic_form.html'
    success_url = reverse_lazy('booktracker:index')


class BookDetail(DetailView):
    model = Book
    template_name = 'booktracker/detail.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['loan_list'] = Loan.objects.filter(book=self.kwargs['pk'])
        context['form'] = BorrowerForm()
        return context


class LoanCreate(CreateView):
    model = Loan
    fields = ['borrower', 'return_deadline']
    template_name = 'booktracker/basic_form.html'
    success_url = reverse_lazy('booktracker:index')

    def form_valid(self, form):
        book = get_object_or_404(Book, id=self.kwargs['book_id'])
        book.is_available = False  # where to check if is_available was True? (too late to do it in form_valid?)
        book.save()
        form.instance.book_id = self.kwargs['book_id']
        return super().form_valid(form)


def book_return(request, book_id):
    book = get_object_or_404(Book, id=book_id)
    book.is_available = True
    book.save()
    return HttpResponseRedirect(reverse('booktracker:detail', args=(book.id,)))

booktracker/templates/booktracker/basic_form.html
<form method="post">
    {% csrf_token %}
    {{ form }}
    <input type="submit" value="Submit">
</form>

booktracker/templates/booktracker/detail.html
<a href="{% url 'booktracker:book_update' book.id %}">Update</a><br>
<a href="{% url 'booktracker:index' %}" >Show all books</a><br>
<ul>
    <li>Title: {{book.title}}</li>
    <li>Author: {{book.author}}</li>
    <li>Year: {{book.pub_year}}</li>
    <li>Available: {{book.is_available}}</li>
</ul>

{% if book.is_available %}
<a href="{% url 'booktracker:book_lend' book.id %}">Lend</a><br>
{% else %}
<a href="{% url 'booktracker:book_return' book.id %}">Return</a><br>
{% endif %}

{% if loan_list %}<strong>Previous borrowers:</strong><br>{% endif %}

{% for loan in loan_list %}
{{loan.borrower}} ({{loan.return_deadline}}) <br>
{% endfor %}

booktracker/templates/booktracker/index.html
<a href="{% url 'booktracker:book_create' %}" >New book</a><br>
<a href="{% url 'booktracker:index' %}" >Show all books</a><br>
<a href="{% url 'booktracker:index' %}?lent=True" >Show only lent books</a><br>

<form action="{% url 'booktracker:index' %}" method="get">
    {{ form_author }}
    <input type="submit" value="Filter"><br>
</form>

<form action="{% url 'booktracker:index' %}" method="get">
    {{ form_borrower }}
    <input type="submit" value="Filter"><br>
</form>

<table>
    <tr>
        <th>Title</th>
        <th>Author</th>
        <th>Year</th>
    </tr>
    {% for book in book_list %}
    <tr>
        <td><a href="{% url 'booktracker:detail' book.id %}" >{{ book.title }}</a></td>
        <td>{{ book.author }}</td>
        <td>{{ book.pub_year }}</td>
    </tr>
    {% endfor %}
</table>